common/xfs: Add a helper to get an inode fork's extent count
[xfstests-dev.git] / common / xfs
1 #
2 # XFS specific common functions.
3 #
4
5 _setup_large_xfs_fs()
6 {
7         fs_size=$1
8         local tmp_dir=/tmp/
9
10         [ "$LARGE_SCRATCH_DEV" != yes ] && return 0
11         [ -z "$SCRATCH_DEV_EMPTY_SPACE" ] && SCRATCH_DEV_EMPTY_SPACE=0
12         [ $SCRATCH_DEV_EMPTY_SPACE -ge $fs_size ] && return 0
13
14         # calculate the size of the file we need to allocate.
15         # Default free space in the FS is 50GB, but you can specify more via
16         # SCRATCH_DEV_EMPTY_SPACE
17         file_size=$(($fs_size - 50*1024*1024*1024))
18         file_size=$(($file_size - $SCRATCH_DEV_EMPTY_SPACE))
19
20         # mount the filesystem, create the file, unmount it
21         _try_scratch_mount 2>&1 >$tmp_dir/mnt.err
22         local status=$?
23         if [ $status -ne 0 ]; then
24                 echo "mount failed"
25                 cat $tmp_dir/mnt.err >&2
26                 rm -f $tmp_dir/mnt.err
27                 return $status
28         fi
29         rm -f $tmp_dir/mnt.err
30
31         xfs_io -F -f \
32                 -c "truncate $file_size" \
33                 -c "falloc -k 0 $file_size" \
34                 -c "chattr +d" \
35                 $SCRATCH_MNT/.use_space 2>&1 > /dev/null
36         export NUM_SPACE_FILES=1
37         status=$?
38         _scratch_unmount
39         if [ $status -ne 0 ]; then
40                 echo "large file prealloc failed"
41                 cat $tmp_dir/mnt.err >&2
42                 return $status
43         fi
44         return 0
45 }
46
47 _scratch_mkfs_xfs_opts()
48 {
49         mkfs_opts=$*
50
51         # remove metadata related mkfs options if mkfs.xfs doesn't them
52         if [ -n "$XFS_MKFS_HAS_NO_META_SUPPORT" ]; then
53                 mkfs_opts=`echo $mkfs_opts | sed "s/-m\s\+\S\+//g"`
54         fi
55
56         _scratch_options mkfs
57
58         echo "$MKFS_XFS_PROG $SCRATCH_OPTIONS $mkfs_opts"
59 }
60
61
62 _scratch_mkfs_xfs_supported()
63 {
64         local mkfs_opts=$*
65
66         _scratch_options mkfs
67
68         $MKFS_XFS_PROG -N $MKFS_OPTIONS $SCRATCH_OPTIONS $mkfs_opts $SCRATCH_DEV
69         local mkfs_status=$?
70
71         # a mkfs failure may be caused by conflicts between $MKFS_OPTIONS and
72         # $mkfs_opts, try again without $MKFS_OPTIONS
73         if [ $mkfs_status -ne 0 -a -n "$mkfs_opts" ]; then
74                 $MKFS_XFS_PROG -N $SCRATCH_OPTIONS $mkfs_opts $SCRATCH_DEV
75                 mkfs_status=$?
76         fi
77         return $mkfs_status
78 }
79
80 # Returns the minimum XFS log size, in units of log blocks.
81 _scratch_find_xfs_min_logblocks()
82 {
83         local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
84
85         # The smallest log size we can specify is 2M (XFS_MIN_LOG_BYTES) so
86         # pass that in and see if mkfs succeeds or tells us what is the
87         # minimum log size.
88         local XFS_MIN_LOG_BYTES=2097152
89
90         # Try formatting the filesystem with all the options given and the
91         # minimum log size.  We hope either that this succeeds or that mkfs
92         # tells us the required minimum log size for the feature set.
93         #
94         # We cannot use _scratch_do_mkfs because it will retry /any/ failed
95         # mkfs with MKFS_OPTIONS removed even if the only "failure" was that
96         # the log was too small.
97         local extra_mkfs_options="$* -N -l size=$XFS_MIN_LOG_BYTES"
98         eval "$mkfs_cmd $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV" \
99                 2>$tmp.mkfserr 1>$tmp.mkfsstd
100         local mkfs_status=$?
101
102         # If the format fails for a reason other than the log being too small,
103         # try again without MKFS_OPTIONS because that's what _scratch_do_mkfs
104         # will do if we pass in the log size option.
105         if [ $mkfs_status -ne 0 ] &&
106            ! egrep -q '(log size.*too small, minimum|external log device.*too small, must be)' $tmp.mkfserr; then
107                 eval "$mkfs_cmd $extra_mkfs_options $SCRATCH_DEV" \
108                         2>$tmp.mkfserr 1>$tmp.mkfsstd
109                 mkfs_status=$?
110         fi
111
112         # mkfs suceeded, so we must pick out the log block size to do the
113         # unit conversion
114         if [ $mkfs_status -eq 0 ]; then
115                 blksz="$(grep '^log.*bsize' $tmp.mkfsstd | \
116                         sed -e 's/log.*bsize=\([0-9]*\).*$/\1/g')"
117                 echo $((XFS_MIN_LOG_BYTES / blksz))
118                 rm -f $tmp.mkfsstd $tmp.mkfserr
119                 return
120         fi
121
122         # Usually mkfs will tell us the minimum log size...
123         if grep -q 'minimum size is' $tmp.mkfserr; then
124                 grep 'minimum size is' $tmp.mkfserr | \
125                         sed -e 's/^.*minimum size is \([0-9]*\) blocks/\1/g'
126                 rm -f $tmp.mkfsstd $tmp.mkfserr
127                 return
128         fi
129         if grep -q 'external log device.*too small, must be' $tmp.mkfserr; then
130                 grep 'external log device.*too small, must be' $tmp.mkfserr | \
131                         sed -e 's/^.*must be at least \([0-9]*\) blocks/\1/g'
132                 rm -f $tmp.mkfsstd $tmp.mkfserr
133                 return
134         fi
135
136         # Don't know what to do, so fail
137         echo "Cannot determine minimum log size" >&2
138         cat $tmp.mkfsstd >> $seqres.full
139         cat $tmp.mkfserr >> $seqres.full
140         rm -f $tmp.mkfsstd $tmp.mkfserr
141 }
142
143 _scratch_mkfs_xfs()
144 {
145         local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
146         local mkfs_filter="sed -e '/less than device physical sector/d' \
147                                -e '/switching to logical sector/d' \
148                                -e '/Default configuration/d'"
149         local tmp=`mktemp -u`
150         local mkfs_status
151
152         _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
153         mkfs_status=$?
154
155         grep -q crc=0 $tmp.mkfsstd && _force_xfsv4_mount_options
156
157         if [ $mkfs_status -eq 0 -a "$LARGE_SCRATCH_DEV" = yes ]; then
158                 # manually parse the mkfs output to get the fs size in bytes
159                 local fs_size
160                 fs_size=`cat $tmp.mkfsstd | perl -ne '
161                         if (/^data\s+=\s+bsize=(\d+)\s+blocks=(\d+)/) {
162                                 my $size = $1 * $2;
163                                 print STDOUT "$size\n";
164                         }'`
165                 _setup_large_xfs_fs $fs_size
166                 mkfs_status=$?
167         fi
168
169         # output mkfs stdout and stderr
170         cat $tmp.mkfsstd
171         cat $tmp.mkfserr >&2
172         rm -f $tmp.mkfserr $tmp.mkfsstd
173
174         return $mkfs_status
175 }
176
177 # Get the size of an allocation unit of a file.  Normally this is just the
178 # block size of the file, but for realtime files, this is the realtime extent
179 # size.
180 _xfs_get_file_block_size()
181 {
182         local path="$1"
183
184         if ! ($XFS_IO_PROG -c "stat -v" "$path" 2>&1 | egrep -q '(rt-inherit|realtime)'); then
185                 _get_block_size "$path"
186                 return
187         fi
188
189         # Otherwise, call xfs_info until we find a mount point or the root.
190         path="$(readlink -m "$path")"
191         while ! $XFS_INFO_PROG "$path" &>/dev/null && [ "$path" != "/" ]; do
192                 path="$(dirname "$path")"
193         done
194         $XFS_INFO_PROG "$path" | grep realtime | sed -e 's/^.*extsz=\([0-9]*\).*$/\1/g'
195 }
196
197 # xfs_check script is planned to be deprecated. But, we want to
198 # be able to invoke "xfs_check" behavior in xfstests in order to
199 # maintain the current verification levels.
200 _xfs_check()
201 {
202         OPTS=" "
203         DBOPTS=" "
204         USAGE="Usage: xfs_check [-fsvV] [-l logdev] [-i ino]... [-b bno]... special"
205
206         OPTIND=1
207         while getopts "b:fi:l:stvV" c; do
208                 case $c in
209                         s) OPTS=$OPTS"-s ";;
210                         t) OPTS=$OPTS"-t ";;
211                         v) OPTS=$OPTS"-v ";;
212                         i) OPTS=$OPTS"-i "$OPTARG" ";;
213                         b) OPTS=$OPTS"-b "$OPTARG" ";;
214                         f) DBOPTS=$DBOPTS" -f";;
215                         l) DBOPTS=$DBOPTS" -l "$OPTARG" ";;
216                         V) $XFS_DB_PROG -p xfs_check -V
217                            return $?
218                            ;;
219                 esac
220         done
221         set -- extra $@
222         shift $OPTIND
223         case $# in
224                 1) ${XFS_DB_PROG}${DBOPTS} -F -i -p xfs_check -c "check$OPTS" $1
225                    status=$?
226                    ;;
227                 2) echo $USAGE 1>&1
228                    status=2
229                    ;;
230         esac
231         return $status
232 }
233
234 _scratch_xfs_db_options()
235 {
236         SCRATCH_OPTIONS=""
237         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
238                 SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
239         echo $SCRATCH_OPTIONS $* $SCRATCH_DEV
240 }
241
242 _scratch_xfs_db()
243 {
244         $XFS_DB_PROG "$@" $(_scratch_xfs_db_options)
245 }
246
247 _test_xfs_db_options()
248 {
249         TEST_OPTIONS=""
250         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
251                 TEST_OPTIONS="-l$TEST_LOGDEV"
252         echo $TEST_OPTIONS $* $TEST_DEV
253 }
254
255 _test_xfs_db()
256 {
257         $XFS_DB_PROG "$@" $(_test_xfs_db_options)
258 }
259
260 _scratch_xfs_admin()
261 {
262         local options=("$SCRATCH_DEV")
263         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
264                 options+=("$SCRATCH_LOGDEV")
265         $XFS_ADMIN_PROG "$@" "${options[@]}"
266 }
267
268 _scratch_xfs_logprint()
269 {
270         SCRATCH_OPTIONS=""
271         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
272                 SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
273         $XFS_LOGPRINT_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
274 }
275
276 _test_xfs_logprint()
277 {
278         TEST_OPTIONS=""
279         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
280                 TEST_OPTIONS="-l$TEST_LOGDEV"
281         $XFS_LOGPRINT_PROG $TEST_OPTIONS $* $TEST_DEV
282 }
283
284 _scratch_xfs_check()
285 {
286         SCRATCH_OPTIONS=""
287         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
288                 SCRATCH_OPTIONS="-l $SCRATCH_LOGDEV"
289         [ "$LARGE_SCRATCH_DEV" = yes ] && \
290                 SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -t"
291         _xfs_check $SCRATCH_OPTIONS $* $SCRATCH_DEV
292 }
293
294 _scratch_xfs_repair()
295 {
296         SCRATCH_OPTIONS=""
297         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
298                 SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
299         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
300                 SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -r$SCRATCH_RTDEV"
301         $XFS_REPAIR_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
302 }
303
304 # this test requires the projid32bit feature to be available in mkfs.xfs.
305 #
306 _require_projid32bit()
307 {
308        _scratch_mkfs_xfs_supported -i projid32bit=1 >/dev/null 2>&1 \
309            || _notrun "mkfs.xfs doesn't have projid32bit feature"
310 }
311
312 _require_projid16bit()
313 {
314         _scratch_mkfs_xfs_supported -i projid32bit=0 >/dev/null 2>&1 \
315            || _notrun "16 bit project IDs not supported on $SCRATCH_DEV"
316 }
317
318 # this test requires the crc feature to be available in mkfs.xfs
319 #
320 _require_xfs_mkfs_crc()
321 {
322         _scratch_mkfs_xfs_supported -m crc=1 >/dev/null 2>&1 \
323            || _notrun "mkfs.xfs doesn't have crc feature"
324 }
325
326 # this test requires the xfs kernel support crc feature
327 #
328 _require_xfs_crc()
329 {
330         _scratch_mkfs_xfs -m crc=1 >/dev/null 2>&1
331         _try_scratch_mount >/dev/null 2>&1 \
332            || _notrun "Kernel doesn't support crc feature"
333         _scratch_unmount
334 }
335
336 # this test requires the xfs kernel support crc feature on scratch device
337 #
338 _require_scratch_xfs_crc()
339 {
340         _scratch_mkfs_xfs >/dev/null 2>&1
341         _try_scratch_mount >/dev/null 2>&1 \
342            || _notrun "Kernel doesn't support crc feature"
343         $XFS_INFO_PROG $SCRATCH_MNT | grep -q 'crc=1' || _notrun "crc feature not supported by this filesystem"
344         _scratch_unmount
345 }
346
347 # this test requires the finobt feature to be available in mkfs.xfs
348 #
349 _require_xfs_mkfs_finobt()
350 {
351         _scratch_mkfs_xfs_supported -m crc=1,finobt=1 >/dev/null 2>&1 \
352            || _notrun "mkfs.xfs doesn't have finobt feature"
353 }
354
355 # this test requires the xfs kernel support finobt feature
356 #
357 _require_xfs_finobt()
358 {
359         _scratch_mkfs_xfs -m crc=1,finobt=1 >/dev/null 2>&1
360         _try_scratch_mount >/dev/null 2>&1 \
361            || _notrun "Kernel doesn't support finobt feature"
362         _scratch_unmount
363 }
364
365 # this test requires xfs sysfs attribute support
366 #
367 _require_xfs_sysfs()
368 {
369         attr=$1
370         sysfsdir=/sys/fs/xfs
371
372         if [ ! -e $sysfsdir ]; then
373                 _notrun "no kernel support for XFS sysfs attributes"
374         fi
375
376         if [ ! -z $1 ] && [ ! -e $sysfsdir/$attr ]; then
377                 _notrun "sysfs attribute '$attr' is not supported"
378         fi
379 }
380
381 # this test requires the xfs sparse inode feature
382 #
383 _require_xfs_sparse_inodes()
384 {
385         _scratch_mkfs_xfs_supported -m crc=1 -i sparse > /dev/null 2>&1 \
386                 || _notrun "mkfs.xfs does not support sparse inodes"
387         _scratch_mkfs_xfs -m crc=1 -i sparse > /dev/null 2>&1
388         _try_scratch_mount >/dev/null 2>&1 \
389                 || _notrun "kernel does not support sparse inodes"
390         _scratch_unmount
391 }
392
393 # check that xfs_db supports a specific command
394 _require_xfs_db_command()
395 {
396         if [ $# -ne 1 ]; then
397                 echo "Usage: _require_xfs_db_command command" 1>&2
398                 exit 1
399         fi
400         command=$1
401
402         _scratch_mkfs_xfs >/dev/null 2>&1
403         _scratch_xfs_db -x -c "help" | grep $command > /dev/null || \
404                 _notrun "xfs_db $command support is missing"
405 }
406
407 # Does the filesystem mounted from a particular device support scrub?
408 _supports_xfs_scrub()
409 {
410         local mountpoint="$1"
411         local device="$2"
412
413         if [ -z "$device" ] || [ -z "$mountpoint" ]; then
414                 echo "Usage: _supports_xfs_scrub mountpoint device"
415                 return 1
416         fi
417
418         if [ ! -b "$device" ] || [ ! -e "$mountpoint" ]; then
419                 return 1
420         fi
421
422         test "$FSTYP" = "xfs" || return 1
423         test -x "$XFS_SCRUB_PROG" || return 1
424
425         # Probe for kernel support...
426         $XFS_IO_PROG -c 'help scrub' 2>&1 | grep -q 'types are:.*probe' || return 1
427         $XFS_IO_PROG -c "scrub probe" "$mountpoint" 2>&1 | grep -q "Inappropriate ioctl" && return 1
428
429         # Scrub can't run on norecovery mounts
430         _fs_options "$device" | grep -q "norecovery" && return 1
431
432         return 0
433 }
434
435 # Save a snapshot of a corrupt xfs filesystem for later debugging.
436 _xfs_metadump() {
437         local metadump="$1"
438         local device="$2"
439         local logdev="$3"
440         local compressopt="$4"
441         shift; shift; shift; shift
442         local options="$@"
443         test -z "$options" && options="-a -o"
444
445         if [ "$logdev" != "none" ]; then
446                 options="$options -l $logdev"
447         fi
448
449         $XFS_METADUMP_PROG $options "$device" "$metadump"
450         res=$?
451         [ "$compressopt" = "compress" ] && [ -n "$DUMP_COMPRESSOR" ] &&
452                 $DUMP_COMPRESSOR "$metadump" &> /dev/null
453         return $res
454 }
455
456 # Snapshot the metadata on the scratch device
457 _scratch_xfs_metadump()
458 {
459         local metadump=$1
460         shift
461         local logdev=none
462
463         [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
464                 logdev=$SCRATCH_LOGDEV
465
466         _xfs_metadump "$metadump" "$SCRATCH_DEV" "$logdev" nocompress "$@"
467 }
468
469 # run xfs_check and friends on a FS.
470 _check_xfs_filesystem()
471 {
472         if [ $# -ne 3 ]; then
473                 echo "Usage: _check_xfs_filesystem device <logdev>|none <rtdev>|none" 1>&2
474                 exit 1
475         fi
476
477         extra_mount_options=""
478         extra_log_options=""
479         extra_options=""
480         device=$1
481         if [ -f $device ]; then
482                 extra_options="-f"
483         fi
484
485         local logdev="$2"
486         if [ "$logdev" != "none" ]; then
487                 extra_log_options="-l$logdev"
488                 extra_mount_options="-ologdev=$logdev"
489         fi
490
491         local rtdev="$3"
492         if [ "$rtdev" != "none" ]; then
493                 extra_rt_options="-r$rtdev"
494                 extra_mount_options=$extra_mount_options" -ortdev=$rtdev"
495         fi
496         extra_mount_options=$extra_mount_options" $MOUNT_OPTIONS"
497
498         [ "$FSTYP" != xfs ] && return 0
499
500         type=`_fs_type $device`
501         ok=1
502
503         # Run online scrub if we can.
504         mntpt="$(_is_dev_mounted $device)"
505         if [ -n "$mntpt" ] && _supports_xfs_scrub "$mntpt" "$device"; then
506                 # Tests can create a scenario in which a call to syncfs() issued
507                 # at the end of the execution of the test script would return an
508                 # error code. xfs_scrub internally calls syncfs() before
509                 # starting the actual online consistency check operation. Since
510                 # such a call to syncfs() fails, xfs_scrub ends up returning
511                 # without performing consistency checks on the test
512                 # filesystem. This can mask a possible on-disk data structure
513                 # corruption. Hence consume such a possible syncfs() failure
514                 # before executing a scrub operation.
515                 $XFS_IO_PROG -c syncfs $mntpt >> $seqres.full 2>&1
516
517                 "$XFS_SCRUB_PROG" $scrubflag -v -d -n $mntpt > $tmp.scrub 2>&1
518                 if [ $? -ne 0 ]; then
519                         _log_err "_check_xfs_filesystem: filesystem on $device failed scrub"
520                         echo "*** xfs_scrub $scrubflag -v -d -n output ***" >> $seqres.full
521                         cat $tmp.scrub >> $seqres.full
522                         echo "*** end xfs_scrub output" >> $serqres.full
523                         ok=0
524                 fi
525                 rm -f $tmp.scrub
526         fi
527
528         if [ "$type" = "xfs" ]; then
529                 # mounted ...
530                 mountpoint=`_umount_or_remount_ro $device`
531         fi
532
533         $XFS_LOGPRINT_PROG -t $extra_log_options $device 2>&1 \
534                 | tee $tmp.logprint | grep -q "<CLEAN>"
535         if [ $? -ne 0 ]; then
536                 _log_err "_check_xfs_filesystem: filesystem on $device has dirty log"
537                 echo "*** xfs_logprint -t output ***"   >>$seqres.full
538                 cat $tmp.logprint                       >>$seqres.full
539                 echo "*** end xfs_logprint output"      >>$seqres.full
540
541                 ok=0
542         fi
543
544         # xfs_check runs out of memory on large files, so even providing the test
545         # option (-t) to avoid indexing the free space trees doesn't make it pass on
546         # large filesystems. Avoid it.
547         if [ "$LARGE_SCRATCH_DEV" != yes ]; then
548                 _xfs_check $extra_log_options $device 2>&1 > $tmp.fs_check
549         fi
550         if [ -s $tmp.fs_check ]; then
551                 _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (c)"
552                 echo "*** xfs_check output ***"         >>$seqres.full
553                 cat $tmp.fs_check                       >>$seqres.full
554                 echo "*** end xfs_check output"         >>$seqres.full
555
556                 ok=0
557         fi
558
559         $XFS_REPAIR_PROG -n $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
560         if [ $? -ne 0 ]; then
561                 _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (r)"
562                 echo "*** xfs_repair -n output ***"     >>$seqres.full
563                 cat $tmp.repair                         >>$seqres.full
564                 echo "*** end xfs_repair output"        >>$seqres.full
565
566                 ok=0
567         fi
568         rm -f $tmp.fs_check $tmp.logprint $tmp.repair
569
570         if [ "$ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
571                 local flatdev="$(basename "$device")"
572                 _xfs_metadump "$seqres.$flatdev.check.md" "$device" "$logdev" \
573                         compress >> $seqres.full
574         fi
575
576         # Optionally test the index rebuilding behavior.
577         if [ -n "$TEST_XFS_REPAIR_REBUILD" ]; then
578                 rebuild_ok=1
579                 $XFS_REPAIR_PROG $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
580                 if [ $? -ne 0 ]; then
581                         _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild)"
582                         echo "*** xfs_repair output ***"        >>$seqres.full
583                         cat $tmp.repair                         >>$seqres.full
584                         echo "*** end xfs_repair output"        >>$seqres.full
585
586                         ok=0
587                         rebuild_ok=0
588                 fi
589                 rm -f $tmp.repair
590
591                 $XFS_REPAIR_PROG -n $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
592                 if [ $? -ne 0 ]; then
593                         _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild-reverify)"
594                         echo "*** xfs_repair -n output ***"     >>$seqres.full
595                         cat $tmp.repair                         >>$seqres.full
596                         echo "*** end xfs_repair output"        >>$seqres.full
597
598                         ok=0
599                         rebuild_ok=0
600                 fi
601                 rm -f $tmp.repair
602
603                 if [ "$rebuild_ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
604                         local flatdev="$(basename "$device")"
605                         _xfs_metadump "$seqres.$flatdev.rebuild.md" "$device" \
606                                 "$logdev" compress >> $seqres.full
607                 fi
608         fi
609
610         if [ $ok -eq 0 ]; then
611                 echo "*** mount output ***"             >>$seqres.full
612                 _mount                                  >>$seqres.full
613                 echo "*** end mount output"             >>$seqres.full
614         elif [ "$type" = "xfs" ]; then
615                 _mount_or_remount_rw "$extra_mount_options" $device $mountpoint
616         fi
617
618         if [ $ok -eq 0 ]; then
619                 status=1
620                 if [ "$iam" != "check" ]; then
621                         exit 1
622                 fi
623                 return 1
624         fi
625
626         return 0
627 }
628
629 _check_xfs_test_fs()
630 {
631         TEST_LOG="none"
632         TEST_RT="none"
633         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
634                 TEST_LOG="$TEST_LOGDEV"
635
636         [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_RTDEV" ] && \
637                 TEST_RT="$TEST_RTDEV"
638
639         _check_xfs_filesystem $TEST_DEV $TEST_LOG $TEST_RT
640         return $?
641 }
642
643 _require_xfs_test_rmapbt()
644 {
645         _require_test
646
647         if [ "$($XFS_INFO_PROG "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
648                 _notrun "rmapbt not supported by test filesystem type: $FSTYP"
649         fi
650 }
651
652 _require_xfs_scratch_rmapbt()
653 {
654         _require_scratch
655
656         _scratch_mkfs > /dev/null
657         _scratch_mount
658         if [ "$($XFS_INFO_PROG "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
659                 _scratch_unmount
660                 _notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
661         fi
662         _scratch_unmount
663 }
664
665 _xfs_bmapx_find()
666 {
667         case "$1" in
668         "attr")
669                 param="a"
670                 ;;
671         "cow")
672                 param="c"
673                 ;;
674         *)
675                 param="e"
676                 ;;
677         esac
678         shift
679         file="$1"
680         shift
681
682         $XFS_IO_PROG -c "bmap -${param}lpv" "$file" | grep -c "$@"
683 }
684
685 # Reset all xfs error handling attributes, set them to original
686 # status.
687 #
688 # Only one argument, and it's mandatory:
689 #  - dev: device name, e.g. $SCRATCH_DEV
690 #
691 # Note: this function only works for XFS
692 _reset_xfs_sysfs_error_handling()
693 {
694         local dev=$1
695
696         if [ ! -b "$dev" -o "$FSTYP" != "xfs" ]; then
697                 _fail "Usage: reset_xfs_sysfs_error_handling <device>"
698         fi
699
700         _set_fs_sysfs_attr $dev error/fail_at_unmount 1
701         echo -n "error/fail_at_unmount="
702         _get_fs_sysfs_attr $dev error/fail_at_unmount
703
704         # Make sure all will be configured to retry forever by default, except
705         # for ENODEV, which is an unrecoverable error, so it will be configured
706         # to not retry on error by default.
707         for e in default EIO ENOSPC; do
708                 _set_fs_sysfs_attr $dev \
709                                    error/metadata/${e}/max_retries -1
710                 echo -n "error/metadata/${e}/max_retries="
711                 _get_fs_sysfs_attr $dev error/metadata/${e}/max_retries
712
713                 _set_fs_sysfs_attr $dev \
714                                    error/metadata/${e}/retry_timeout_seconds 0
715                 echo -n "error/metadata/${e}/retry_timeout_seconds="
716                 _get_fs_sysfs_attr $dev \
717                                    error/metadata/${e}/retry_timeout_seconds
718         done
719 }
720
721 # Skip if we are running an older binary without the stricter input checks.
722 # Make multiple checks to be sure that there is no regression on the one
723 # selected feature check, which would skew the result.
724 #
725 # At first, make a common function that runs the tests and returns
726 # number of failed cases.
727 _xfs_mkfs_validation_check()
728 {
729         local tmpfile=`mktemp`
730         local cmd="$MKFS_XFS_PROG -f -N -d file,name=$tmpfile,size=1g"
731
732         $cmd -s size=8s >/dev/null 2>&1
733         local sum=$?
734
735         $cmd -l version=2,su=260k >/dev/null 2>&1
736         sum=`expr $sum + $?`
737
738         rm -f $tmpfile
739         return $sum
740 }
741
742 # Skip the test if all calls passed - mkfs accepts invalid input
743 _require_xfs_mkfs_validation()
744 {
745         _xfs_mkfs_validation_check
746         if [ "$?" -eq 0 ]; then
747                 _notrun "Requires newer mkfs with stricter input checks: the oldest supported version of xfsprogs is 4.7."
748         fi
749 }
750
751 # The opposite of _require_xfs_mkfs_validation.
752 _require_xfs_mkfs_without_validation()
753 {
754         _xfs_mkfs_validation_check
755         if [ "$?" -ne 0 ]; then
756                 _notrun "Requires older mkfs without strict input checks: the last supported version of xfsprogs is 4.5."
757         fi
758 }
759
760 # XFS ability to change UUIDs on V5/CRC filesystems
761 #
762 _require_meta_uuid()
763 {
764         # This will create a crc fs on $SCRATCH_DEV
765         _require_xfs_crc
766
767         _scratch_xfs_db -x -c "uuid restore" 2>&1 \
768            | grep -q "invalid UUID\|supported on V5 fs" \
769            && _notrun "Userspace doesn't support meta_uuid feature"
770
771         _scratch_xfs_db -x -c "uuid generate" >/dev/null 2>&1
772
773         _try_scratch_mount >/dev/null 2>&1 \
774            || _notrun "Kernel doesn't support meta_uuid feature"
775         _scratch_unmount
776 }
777
778 # this test requires mkfs.xfs have case-insensitive naming support
779 _require_xfs_mkfs_ciname()
780 {
781         _scratch_mkfs_xfs_supported -n version=ci >/dev/null 2>&1 \
782                 || _notrun "need case-insensitive naming support in mkfs.xfs"
783 }
784
785 # this test requires mkfs.xfs have configuration file support
786 _require_xfs_mkfs_cfgfile()
787 {
788         echo > /tmp/a
789         _scratch_mkfs_xfs_supported -c options=/tmp/a >/dev/null 2>&1
790         res=$?
791         rm -rf /tmp/a
792         test $res -eq 0 || _notrun "need configuration file support in mkfs.xfs"
793 }
794
795 # XFS_DEBUG requirements
796 _require_xfs_debug()
797 {
798         if grep -q "debug 0" /proc/fs/xfs/stat; then
799                 _notrun "Require XFS built with CONFIG_XFS_DEBUG"
800         fi
801 }
802 _require_no_xfs_debug()
803 {
804         if grep -q "debug 1" /proc/fs/xfs/stat; then
805                 _notrun "Require XFS built without CONFIG_XFS_DEBUG"
806         fi
807 }
808
809 # Require that assertions will not crash the system.
810 #
811 # Assertions would always crash the system if XFS assert fatal was enabled
812 # (CONFIG_XFS_ASSERT_FATAL=y).  If a test is designed to trigger an assertion,
813 # skip the test on a CONFIG_XFS_ASSERT_FATAL built XFS by default.  Note:
814 # CONFIG_XFS_ASSERT_FATAL can be disabled by setting bug_on_assert to zero if
815 # we want test to run.
816 _require_no_xfs_bug_on_assert()
817 {
818         if [ -f /sys/fs/xfs/debug/bug_on_assert ]; then
819                 grep -q "1" /sys/fs/xfs/debug/bug_on_assert && \
820                    _notrun "test requires XFS bug_on_assert to be off, turn it off to run the test"
821         else
822                 # Note: Prior to the creation of CONFIG_XFS_ASSERT_FATAL (and
823                 # the sysfs knob bug_on_assert), assertions would always crash
824                 # the system if XFS debug was enabled (CONFIG_XFS_DEBUG=y).  If
825                 # a test is designed to trigger an assertion and the test
826                 # designer does not want to hang fstests, skip the test.
827                 _require_no_xfs_debug
828         fi
829 }
830
831 # Get a metadata field
832 # The first arg is the field name
833 # The rest of the arguments are xfs_db commands to find the metadata.
834 _scratch_xfs_get_metadata_field()
835 {
836         local key="$1"
837         shift
838
839         local grep_key="$(echo "${key}" | tr '[]()' '....')"
840         local cmds=()
841         local arg
842         for arg in "$@"; do
843                 cmds+=("-c" "${arg}")
844         done
845         _scratch_xfs_db "${cmds[@]}" -c "print ${key}" | grep "^${grep_key}" | \
846                 sed -e 's/^.* = //g'
847 }
848
849 # Set a metadata field
850 # The first arg is the field name
851 # The second arg is the new value
852 # The rest of the arguments are xfs_db commands to find the metadata.
853 _scratch_xfs_set_metadata_field()
854 {
855         local key="$1"
856         local value="$2"
857         shift; shift
858
859         local cmds=()
860         local arg
861         for arg in "$@"; do
862                 cmds+=("-c" "${arg}")
863         done
864
865         local wr_cmd="write"
866         _scratch_xfs_db -x -c "help write" | egrep -q "(-c|-d)" && value="-- ${value}"
867         _scratch_xfs_db -x -c "help write" | egrep -q "(-d)" && wr_cmd="${wr_cmd} -d"
868         _scratch_xfs_db -x "${cmds[@]}" -c "${wr_cmd} ${key} ${value}"
869 }
870
871 _scratch_xfs_get_sb_field()
872 {
873         _scratch_xfs_get_metadata_field "$1" "sb 0"
874 }
875
876 _scratch_xfs_set_sb_field()
877 {
878         _scratch_xfs_set_metadata_field "$1" "$2" "sb 0"
879 }
880
881 # Before xfsprogs commit 4222d000ed("db: write via array indexing doesn't
882 # work"), xfs_db command to write a specific AGFL index doesn't work. It's a
883 # bug in a diagnostic tool that is only used by XFS developers as a test
884 # infrastructure, so it's fine to treat it as a infrastructure dependency as
885 # all other _require rules.
886 _require_xfs_db_write_array()
887 {
888         local supported=0
889
890         _require_test
891         touch $TEST_DIR/$seq.img
892         $MKFS_XFS_PROG -d file,name=$TEST_DIR/$seq.img,size=512m >/dev/null 2>&1
893         $XFS_DB_PROG -x -c "agfl 0" -c "write bno[32] 78" $TEST_DIR/$seq.img \
894                 >/dev/null 2>&1
895         $XFS_DB_PROG -x -c "agfl 0" -c "print bno[32]" $TEST_DIR/$seq.img \
896                 | grep -q "bno\[32\] = 78" && supported=1
897         rm -f $TEST_DIR/$seq.img
898         [ $supported -eq 0 ] && _notrun "xfs_db write can't support array"
899 }
900
901 _require_xfs_spaceman_command()
902 {
903         if [ -z "$1" ]; then
904                 echo "Usage: _require_xfs_spaceman_command command [switch]" 1>&2
905                 exit 1
906         fi
907         local command=$1
908         shift
909         local param="$*"
910         local param_checked=0
911         local opts=""
912
913         _require_command "$XFS_SPACEMAN_PROG" "xfs_spaceman"
914
915         testfile=$TEST_DIR/$$.xfs_spaceman
916         touch $testfile
917         case $command in
918         "health")
919                 testio=`$XFS_SPACEMAN_PROG -c "health $param" $TEST_DIR 2>&1`
920                 param_checked=1
921                 ;;
922         *)
923                 testio=`$XFS_SPACEMAN_PROG -c "help $command" $TEST_DIR 2>&1`
924         esac
925
926         rm -f $testfile 2>&1 > /dev/null
927         echo $testio | grep -q "not found" && \
928                 _notrun "xfs_spaceman $command support is missing"
929         echo $testio | grep -q "Operation not supported" && \
930                 _notrun "xfs_spaceman $command failed (old kernel/wrong fs?)"
931         echo $testio | grep -q "Invalid" && \
932                 _notrun "xfs_spaceman $command failed (old kernel/wrong fs/bad args?)"
933         echo $testio | grep -q "foreign file active" && \
934                 _notrun "xfs_spaceman $command not supported on $FSTYP"
935         echo $testio | grep -q "Inappropriate ioctl for device" && \
936                 _notrun "xfs_spaceman $command support is missing (missing ioctl?)"
937         echo $testio | grep -q "Function not implemented" && \
938                 _notrun "xfs_spaceman $command support is missing (missing syscall?)"
939
940         [ -n "$param" ] || return
941
942         if [ $param_checked -eq 0 ]; then
943                 $XFS_SPACEMAN_PROG -c "help $command" | grep -q "^ $param --" || \
944                         _notrun "xfs_spaceman $command doesn't support $param"
945         fi
946 }
947
948 _scratch_get_sfdir_prefix() {
949         local dir_ino="$1"
950
951         for prefix in "u.sfdir3" "u.sfdir2" "u3.sfdir3"; do
952                 if [ -n "$(_scratch_xfs_get_metadata_field \
953                                 "${prefix}.hdr.parent.i4" \
954                                 "inode ${dir_ino}")" ]; then
955                         echo "${prefix}"
956                         return 0
957                 fi
958         done
959         _scratch_xfs_db -c "inode ${dir_ino}" -c 'p' >> $seqres.full
960         return 1
961 }
962
963 _scratch_get_bmx_prefix() {
964         local ino="$1"
965
966         for prefix in "u3.bmx" "u.bmx"; do
967                 if [ -n "$(_scratch_xfs_get_metadata_field \
968                                 "${prefix}[0].startblock" \
969                                 "inode ${ino}")" ]; then
970                         echo "${prefix}"
971                         return 0
972                 fi
973         done
974         _scratch_xfs_db -c "inode ${ino}" -c 'p' >> $seqres.full
975         return 1
976 }
977
978 _scratch_get_iext_count()
979 {
980         local ino=$1
981         local whichfork=$2
982         local field=""
983
984         case $whichfork in
985                 "attr")
986                         field=core.naextents
987                         ;;
988                 "data")
989                         field=core.nextents
990                         ;;
991                 *)
992                         return 1
993         esac
994
995         _scratch_xfs_get_metadata_field $field "inode $ino"
996 }
997
998 #
999 # Ensures that we don't pass any mount options incompatible with XFS v4
1000 #
1001 _force_xfsv4_mount_options()
1002 {
1003         local gquota=0
1004         local pquota=0
1005
1006         # Can't have group and project quotas in XFS v4
1007         echo "$MOUNT_OPTIONS" | egrep -q "(gquota|grpquota|grpjquota=|gqnoenforce)" && gquota=1
1008         echo "$MOUNT_OPTIONS" | egrep -q "(\bpquota|prjquota|pqnoenforce)" && pquota=1
1009
1010         if [ $gquota -gt 0 ] && [ $pquota -gt 0 ]; then
1011                 export MOUNT_OPTIONS=$(echo $MOUNT_OPTIONS \
1012                         | sed   -e 's/gquota/QUOTA/g'      \
1013                                 -e 's/grpquota/QUOTA/g'    \
1014                                 -e 's/grpjquota=[^, ]/QUOTA/g' \
1015                                 -e 's/gqnoenforce/QUOTA/g' \
1016                                 -e "s/QUOTA/defaults/g")
1017         fi
1018         echo "MOUNT_OPTIONS = $MOUNT_OPTIONS" >>$seqres.full
1019 }
1020
1021 # Find AG count of mounted filesystem
1022 _xfs_mount_agcount()
1023 {
1024         $XFS_INFO_PROG "$1" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g'
1025 }
1026
1027 # Wipe the superblock of each XFS AGs
1028 _try_wipe_scratch_xfs()
1029 {
1030         local num='^[0-9]+$'
1031         local agcount
1032         local agsize
1033         local dbsize
1034
1035         # Try to wipe each SB if there's an existed XFS
1036         agcount=`_scratch_xfs_get_sb_field agcount 2>/dev/null`
1037         agsize=`_scratch_xfs_get_sb_field agblocks 2>/dev/null`
1038         dbsize=`_scratch_xfs_get_sb_field blocksize 2>/dev/null`
1039         if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
1040                 for ((i = 0; i < agcount; i++)); do
1041                         $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
1042                                 $SCRATCH_DEV >/dev/null;
1043                 done
1044         fi
1045
1046         # Try to wipe each SB by default mkfs.xfs geometry
1047         local tmp=`mktemp -u`
1048         unset agcount agsize dbsize
1049         _scratch_mkfs_xfs -N 2>/dev/null | perl -ne '
1050                 if (/^meta-data=.*\s+agcount=(\d+), agsize=(\d+) blks/) {
1051                         print STDOUT "agcount=$1\nagsize=$2\n";
1052                 }
1053                 if (/^data\s+=\s+bsize=(\d+)\s/) {
1054                         print STDOUT "dbsize=$1\n";
1055                 }' > $tmp.mkfs
1056
1057         . $tmp.mkfs
1058         if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
1059                 for ((i = 0; i < agcount; i++)); do
1060                         $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
1061                                 $SCRATCH_DEV >/dev/null;
1062                 done
1063         fi
1064         rm -f $tmp.mkfs
1065 }
1066
1067 _require_xfs_copy()
1068 {
1069         [ -n "$XFS_COPY_PROG" ] || _notrun "xfs_copy binary not yet installed"
1070         [ "$USE_EXTERNAL" = yes ] && \
1071                 _notrun "Cannot xfs_copy with external devices"
1072 }